# Class ModuleReference

java.lang.Object
java.lang.module.ModuleReference

public abstract class ModuleReference extends Object
A reference to a module's content.

A module reference is a concrete implementation of this class that implements the abstract methods defined by this class. It contains the module's descriptor and its location, if known. It also has the ability to create a `ModuleReader` in order to access the module's content, which may be inside the Java run-time system itself or in an artifact such as a modular JAR file.

Since:
  9
See Also:
  - `ModuleFinder`
  - `ModuleReader`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ModuleReference(ModuleDescriptor descriptor, URI location)`
Constructs a new instance of this class.

## Method Summary

Modifier and Type
Method
Description
`final ModuleDescriptor`
`descriptor()`
Returns the module descriptor.
`final Optional<URI>`
`location()`
Returns the location of this module's content, if known.
`abstract ModuleReader`
`open()`
Opens the module content for reading.

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ModuleReference

protected ModuleReference(ModuleDescriptor descriptor, URI location)
Constructs a new instance of this class.

Parameters:
  `descriptor` - The module descriptor
  `location` - The module location or `null` if not known

## Method Details

### descriptor

public final ModuleDescriptor descriptor()
Returns the module descriptor.

Returns:
  The module descriptor

### location

public final Optional<URI> location()
Returns the location of this module's content, if known.

Returns:
  The location or an empty `Optional` if not known

### open

public abstract ModuleReader open() throws IOException
Opens the module content for reading.

Returns:
  A `ModuleReader` to read the module
Throws:
  `IOException` - If an I/O error occurs